SET SERVEROUTPUT ON;
spool Pruebas_Proc_Pk.log
prompt Pruebas procedimientos de los PKs...

---- PRUEBAS DE lOS PROCEDIMIENTOS DE LOS PACKAGES ----
DECLARE
  RSP VARCHAR2(300);
BEGIN
  -- ********** ALTA, BAJA Y MODIFICACIN DE LOS CENSOS
  /**************************************
   *  MANTENIMIENTO PAISES
   **************************************/
 
  -- Insertar pas
  PK_CENSOS.INS_PAIS ('ja', 'JAJAJA', RSP);
  dbms_output.put_line('Inserto Pas RET:'||RSP);
 -- Insertar pas Existente
  PK_CENSOS.INS_PAIS ('ES', 'ESPAA REPETIDA', RSP);
  dbms_output.put_line('Inserto Pas RET:'||RSP);
  -- Modificar pas
  PK_CENSOS.UPD_PAIS ('ja', 'JAMAICA', RSP);
  dbms_output.put_line('UPD_Pas RET:'||RSP);
  -- Borrar pas
  PK_CENSOS.DEL_PAIS ('JA', RSP);
  dbms_output.put_line('DEL_Pas RET:'||RSP);

  /**************************************
   *  MANTENIMIENTO REGION
   **************************************/
  -- Insertar regin
  PK_CENSOS.INS_REGION ('DE', 'Sajonia', RSP);
  dbms_output.put_line('Inserto Regin RET:'||RSP);
  -- Insertar regin en un pas inexistente
  PK_CENSOS.INS_REGION ('HA', 'JAJA', RSP);
  dbms_output.put_line('Inserto Regin RET:'||RSP);
  -- Modificar regin
  PK_CENSOS.UPD_REGION(2, 'aragn', RSP);
  dbms_output.put_line('UPD Regin RET:'||RSP);
  -- Borrar regin
  PK_CENSOS.DEL_REGION (71, RSP);
  dbms_output.put_line('DEL Regin RET:'||RSP);
  
  /**************************************
   *  MANTENIMIENTO LOCALIDADES
   **************************************/
  -- Insertar Localidad
  PK_CENSOS.INS_LOCALI ('DE', 56, 'STUTTGART', RSP);
  dbms_output.put_line('Inserto Localidad RET:'||RSP);
  PK_CENSOS.INS_LOCALI ('DE', 59, 'BERLN', RSP);
  dbms_output.put_line('Inserto Localidad RET:'||RSP);
  -- Modificar Localidad
  PK_CENSOS.UPD_LOCALI (165, 'VALLE AURINA', RSP);
  dbms_output.put_line('UPD Localidad RET:'||RSP);
  -- Borrar Localidad
  PK_CENSOS.DEL_LOCALI (187, RSP);
  dbms_output.put_line('DEL Localidad RET:'||RSP);  
  
  -- ********** ALTA, BAJA Y MODIFICACIN PERSONAS ----

  /**************************************
   *  MANTENIMIENTO PERSONAS
   **************************************/

  -- Alta PERSONAS
  PK_PERSONAS.INS_PERSONAS (TO_DATE('10101980','DDMMYYYY'), 1, RSP);
  dbms_output.put_line('Insera personas RET:'||RSP); 
  -- Baja PERSONAS 
  PK_PERSONAS.DEL_PERSONAS (1100, RSP);
  dbms_output.put_line('DEL personas RET:'||RSP);  
  -- Modificacin PERSONAS 
  PK_PERSONAS.UPD_PERSONAS (1118, TO_DATE('31101948','DDMMYYYY'), 1, RSP);
  dbms_output.put_line('UPD personas RET:'||RSP);  
  
  -- Baja y Alta PERSONAS/censo
  PK_PERSONAS.DEL_PERSOCENSO(1118, RSP);
  dbms_output.put_line('DEL censos persona RET:'||RSP);
  PK_PERSONAS.INS_PERSOCENSO (1118,'ES', 32, 116, RSP);
  dbms_output.put_line('UPD censos persona RET:'||RSP);  
  PK_PERSONAS.INS_PERSOCENSO (1118,'IT', 32, 116, RSP);
  dbms_output.put_line('UPD censos persona RET:'||RSP);  
  PK_PERSONAS.INS_PERSOCENSO (1121,'DE', 56, 188, RSP);
  dbms_output.put_line('UPD censos persona RET:'||RSP);   
  PK_PERSONAS.INS_PERSOCENSO (1121,'DE', 56, 188, RSP);
  dbms_output.put_line('UPD censos persona RET:'||RSP);   

  /**************************************
   *  ALTA PERSONAS-VOTACION
   **************************************/
  -- Inserta votacin de todas las personas de Italia que votaran 
  -- una opcin aleatoriamente de la votacin 3.
  
  FOR I IN (SELECT idperson, ROUND((idperson/450),0)+1 pnopcio  
              FROM PERSOCENSO 
             WHERE CODPAIS='IT'
               AND FBAJA IS NULL) LOOP
      PK_PERSONAS.INS_VOTAPERSONA (3, I.IDPERSON, I.pnopcio, RSP);
  END LOOP;
  --
  PK_PERSONAS.INS_VOTAPERSONA (3, 40, 1, rsp);
  dbms_output.put_line('Inserta votacin de persona que ya ha votado RET:'||RSP);
  PK_PERSONAS.INS_VOTAPERSONA (3, 497, 2, rsp);
  dbms_output.put_line('Inserta votacin de persona que ya ha votado RET:'||RSP);
  -- ********** ALTA, BAJA Y MODIFICACIN VOTACIONES ----
  /**************************************
   *  MANTENIMIENTO VOTACIONES
   **************************************/
  -- Alta nueva votacin
  
  PK_VOTACION.INS_VOTACION ('PRUEBA',
                            'PRUEBA DE VOTACION',
                            'FERNANDO FLORES',
                          to_date('02012012','ddmmyyyy'),
                          to_date('04012012','ddmmyyyy'),
                          to_date('15122011','ddmmyyyy'),
                          NULL,
                          RSP);
  dbms_output.put_line('Inserta votacin RET:'||RSP);
  
  PK_VOTACION.UPD_ESTADO_VOTA (5, 1, RSP);  
  dbms_output.put_line('Cambio estado votacin 1 RET:'||RSP);
  -- Baja de una votacin
  PK_VOTACION.DEL_VOTACION (6, RSP);
  dbms_output.put_line('Borra votacin RET:'||RSP);
  -- Modificacin de una votacin
  PK_VOTACION.UPD_VOTACION (5,
                            'TRABAJO',
                            'En estos momentos est trabajando?',
                            'FERNANDO FLORES',
                            to_date('02012012','ddmmyyyy'),
                            to_date('04012012','ddmmyyyy'),
                            to_date('15122011','ddmmyyyy'),
                            NULL,
                            RSP);
  dbms_output.put_line('Modificacion total votacin RET:'||RSP);

  -- Modificacin de una votacin
  PK_VOTACION.UPD_VOTACION (5,'FERNANDO FLORES',to_date('04012012','ddmmyyyy'),
                            'WWW.ESTRABAJO.COM', RSP);
  dbms_output.put_line('Modificacion parcial votacin RET:'||RSP); 
                           
  -- Modificacin del estado de una votacin
  PK_VOTACION.UPD_ESTADO_VOTA (1, 3, RSP);
  dbms_output.put_line('Cambio estado votacin 1 RET:'||RSP);  
  PK_VOTACION.UPD_ESTADO_VOTA (2, 3, RSP);
  dbms_output.put_line('Cambio estado votacin 2  RET:'||RSP);
  PK_VOTACION.UPD_ESTADO_VOTA (3, 3, RSP);  
  dbms_output.put_line('Cambio estado votacin 3 RET:'||RSP);
  
  /**************************************
   *  MANTENIMIENTO OPCIONES
   **************************************/

  -- Alta nuevas opciones para una votacin
  PK_VOTACION.INS_OPCION (5, 1, 'Siii', RSP);
  dbms_output.put_line('Inserta nueva opcin RET:'||RSP);
  PK_VOTACION.INS_OPCION (5, 2, 'No', RSP);
  dbms_output.put_line('Inserta nueva opcin RET:'||RSP);
  PK_VOTACION.INS_OPCION (5, 3, 'A veces', RSP);
  dbms_output.put_line('Inserta nueva opcin RET:'||RSP);
  -- baja de una opcin de una votacin
  PK_VOTACION.DEL_OPCION (5, 3, RSP);
  dbms_output.put_line('Borra opcin RET:'||RSP);
  -- Modificacin de una opcin de una votacin
  PK_VOTACION.UPD_OPCION (5, 1, 'Si', RSP);
  dbms_output.put_line('Modifica opcin RET:'||RSP);
 
  /**************************************
   *  MANTENIMIENTO CENSO - VOTACION
   **************************************/
 
  -- Se asigna el censo al que va ir dirigida la votacin
  PK_VOTACION.INS_VOTACENSO (5, 'ES', 8, NULL, RSP);
  dbms_output.put_line('Asigna un censo a una votacin RET:'||RSP);
  -- Se desasigna el censo al que va ir dirigida la votacin
  PK_VOTACION.DEL_VOTACENSO (5, 6, RSP);
  dbms_output.put_line('Da de baja el censo de una votacin RET:'||RSP);
  -- Se asigna el censo al que va ir dirigida la votacin
  PK_VOTACION.INS_VOTACENSO (5, 'ES', null, NULL, RSP);
  dbms_output.put_line('Asigna un censo a una votacin RET:'||RSP);

END;
/
SET SERVEROUTPUT OFF
spool off
