spool Pruebas_consultas.log
prompt Pruebas Modulo Consultas...
prompt
------------------ MODULO DE CONSULTAS ---------------------
prompt Consulta A: Listado de todas las votaciones por pais o censo global mostrando informacin y 
prompt             de cada votacin y resultados de la misma, en el caso de estar finalizada
-- -----------------------------------------------------------------------------------------------------
-- Consulta A: Listado de todas las votaciones por pais o censo global mostrando informacin
-- de cada votacin y resultados de la misma, en el caso de estar finalizada
-- -----------------------------------------------------------------------------------------------------
SET LINESIZE 250
SET PAGESIZE 30
SELECT * FROM TABLE(FLISTA_VOTAPPAIS(null));

prompt Consulta B: Listado de las 10 votaciones con ms diferencia porcentual de votos entre la 
prompt             opcin mas y menos votadas. Mostrando su informacin bsica.
-- -----------------------------------------------------------------------------------------------------
-- Consulta B: listado de las 10 votaciones con ms diferencia porcentual de votos entre la 
-- opcin mas y menos votadas. Mostrando su informacin bsica.
-- -----------------------------------------------------------------------------------------------------
SET LINESIZE 250
SET PAGESIZE 30

SELECT * FROM TABLE(FTOPTENMASVOTA);

prompt Consulta C: Listado de las 10 votaciones con menos diferencia porcentual de votos entre la 
prompt             opcin mas y menos votadas. Mostrando su informacin bsica.
-- -----------------------------------------------------------------------------------------------------
-- Consulta C: listado de las 10 votaciones con menos diferencia porcentual de votos entre la 
-- opcin mas y menos votadas. Mostrando su informacin bsica.
-- -----------------------------------------------------------------------------------------------------
SET LINESIZE 250
SET PAGESIZE 30

SELECT * FROM TABLE(FTOPTENMENVOTA);

prompt Consulta D: Listado de todos los censos a los que ha pertenecido o pertenece una persona. Mostrando los datos bsicos.
-- -----------------------------------------------------------------------------------------------------
-- Consulta D: Listado de todos los censos a los que ha pertenecido o pertenece una persona.
-- Mostrando los datos bsicos.
-- -----------------------------------------------------------------------------------------------------
SET LINESIZE 250
SET PAGESIZE 30

SELECT * FROM TABLE(FCENSOPERSONA(1));

prompt Consulta E: Listado de todas las votaciones en las que ha participado un ciudadano y las que ha podido participar 
prompt             y no ha participado. Mostrando los datos bsicos.
-- -----------------------------------------------------------------------------------------------------
-- Consulta E: Todas las votaciones en las que ha participado un ciudadano y las que ha podido participar y no ha
--  participado. Mostrando los datos bsicos.
-- -----------------------------------------------------------------------------------------------------
SET LINESIZE 250
SET PAGESIZE 30
SELECT * FROM TABLE(FVOTAPERSONA(1));

prompt Pruebas Modulo Estadistico...
prompt
----------------- MODULO ESTADISTICO -----------------------
set pagesize 20
set linesize 200
set heading on
set echo off

prompt Estadistica 1: Dado un pas y ao, mostrar el nmero de votaciones finalizadas que se han producido.  
-- -------------------------------------------------------------------------------------------------
-- 1: Dado un pas y ao, mostrar el nmero de votaciones finalizadas que se han producido. 
-- -------------------------------------------------------------------------------------------------

SELECT v.codpais, p.tpais, v.nanyo, v.nvotafin
  FROM VOTFIN_PAISANYO V, PAISES P
 WHERE p.codpais = v.codpais
   AND v.nanyo = 2011
   AND v.codpais =  'ES';

prompt Estadistica 2: Dado un censo y ao, mostrar el valor medio del % de participacin, teniendo en cuenta todas 
prompt                las votaciones asociadas aquel censo electoral que ha finalizado ese ao.
-- -------------------------------------------------------------------------------------------------
-- 2: Dado un censo y ao, mostrar el valor medio del % de participacin, teniendo en cuenta todas 
--    las votaciones asociadas aquel censo electoral que ha finalizado ese ao. 
--    tipos de censo : 0 - Global.
--                     1 - Estatal. Si no informa pais saldrn todos
--                     2 - Regional. Si no informa el pas ni la regin saldrn todos
--                     3 - Local. Si no informa el pas ni la regin ni la localidad saldrn todas.
-- -------------------------------------------------------------------------------------------------
SELECT v.nanyo, v.tipcenso, v.codpais, v.idregion, v.idlocali, v.nmedppar
  FROM VMEDPART_CENSANYO V
 WHERE v.nanyo = 2011
   AND V.TIPCENSO = 1
   AND v.codpais = 'ES'
ORDER BY v.nanyo, v.tipcenso;

prompt Estadistica 3: Dado un censo y ao, mostrar el numero de votaciones que han finalizado ese ao que ha tenido asociadas ese censo.
-- -------------------------------------------------------------------------------------------------
-- 3: Dado un censo y ao, mostrar el numero de votaciones que han finalizado ese ao que ha tenido 
--    asociadas ese censo.
--    tipos de censo : 0 - Global.
--                     1 - Estatal. Si no informa pais saldrn todos
--                     2 - Regional. Si no informa el pas ni la regin saldrn todos
--                     3 - Local. Si no informa el pas ni la regin ni la localidad saldrn todas.
-- -------------------------------------------------------------------------------------------------
SELECT v.nanyo, v.tipcenso, v.codpais, v.idregion, v.idlocali, v.nvotafin
  FROM VMEDPART_CENSANYO V
 WHERE v.nanyo = 2011
   AND V.TIPCENSO = 0;

prompt Estadistica 4: Dado un ao, muestra la votacin que ms participacin ha tenido. 
-- -------------------------------------------------------------------------------------------------
-- 4: Dado un ao, muestra la votacin que ms participacin ha tenido.
-- -------------------------------------------------------------------------------------------------
SELECT vp.nanyo, vp.idvota, v.ttitulo, vp.nvotapar, vp.pparti
  FROM VOTMASPART_ANYO vp, VOTACION v
 WHERE vp.idvota = v.idvota
   and vp.NANYO = 2011;

prompt Estadistica 5: Dado un ao, mostrar la localidad Europea que ms votos han emitido sus ciudadanos.
-- -------------------------------------------------------------------------------------------------
-- 5: Dado un ao, mostrar la localidad Europea que ms votos han emitido sus ciudadanos.
-- -------------------------------------------------------------------------------------------------
SELECT vl.nanyo,vl.codpais, r.tregion, l.tlocali, v.idvota, v.ttitulo, vl.nvotmpar
  FROM VOTMASP_LOCANY vl, LOCALIDAD l, region r, votacion v
 WHERE vl.idlocali = l.idlocali
   and vl.idregion = r.idregion
   and vl.idvota = v.idvota
   and vl.nanyo = 2011; 

prompt Estadistica 6: Dado un ao, mostrar el % de ciudadanos que nunca han votado y han estado convocados
-- -------------------------------------------------------------------------------------------------
-- 6: Dado un ao, mostrar el % de ciudadanos que nunca han votado y han estado convocados
-- -------------------------------------------------------------------------------------------------
SELECT p.nanyo, p.ppernvot
  FROM PCIUNOVOT_ANYO p
 WHERE p.nanyo = 2011;

prompt Estadistica 7: Muestra la Votacin/es que histricamente han tenido ms participacin
-- -------------------------------------------------------------------------------------------------
-- 7: Muestra la Votacin/es que histricamente han tenido ms participacin
-- -------------------------------------------------------------------------------------------------
SELECT v.idvota, v.ttitulo, h.ntotpar, h.pparti
  FROM HIS_VOTMASPARTI h, VOTACION v
 WHERE v.idvota = h.idvota;

prompt Estadistica  8: Muestra la Votacin/es que histricamente ha tenido MS diferencia porcentual entre opciones.
-- -------------------------------------------------------------------------------------------------
-- 8: Muestra la Votacin/es que histricamente ha tenido MS diferencia porcentual entre opciones.
-- ------------------------------------------------------------------------------------------------- 
SELECT H.idvota, v.ttitulo, h.pdifer 
  FROM HIS_VMASDIFOPC h, VOTACION v
 WHERE v.idvota = h.idvota;

prompt Estadistica  9: Muestra la Votacin/es que histricamente ha tenido MENOS diferencia porcentual entre opciones.
-- -------------------------------------------------------------------------------------------------
-- 9: Muestra la Votacin/es que histricamente ha tenido MENOS diferencia porcentual entre opciones.
-- ------------------------------------------------------------------------------------------------- 
SELECT H.idvota, v.ttitulo, h.pdifer 
  FROM HIS_VMENDIFOPC h, VOTACION v
 WHERE v.idvota = h.idvota;

prompt Estadistica 10: Muestra el numero mximo historico de votaciones en las que ha participado una persona.
-- -------------------------------------------------------------------------------------------------
-- 10: Muestra el numero mximo historico de votaciones en las que ha participado una persona.
-- ------------------------------------------------------------------------------------------------- 
SELECT H.IDPERSON, v.CODPAIS, H.NMAXVOT 
  FROM HIS_VOTTOPPER h, PERSOCENSO V
 WHERE H.idperson = v.idperson
   AND v.fbaja IS NULL;


spool off
