spool 3-cr_tipos_objetos.log
prompt creando tipos de objetos...
--TIPO REGISTRO DEL LISTADO DE VOTACIONES POR PAIS
DROP TYPE VOTAPAIS_TAB;
CREATE OR REPLACE TYPE VOTAPAIS_OBJ as object (
  CODPAIS        VARCHAR2(02),
  TTITULO        VARCHAR2(20),
  FFECINI        DATE,
  FFECFIN        DATE,
  NCAPVOT        NUMBER(8),
  NVOTTOT        NUMBER(8),
  TESTADO        VARCHAR2(10), 
  PPARTI         NUMBER(5,2),
  GANADORA       VARCHAR2(50), 
  PRESTOT        VARCHAR2(7)
);
/
--TIPO QUE ALMACENA LOS REGISTROS DEL LISTADO DE VOTACIONES POR PAIS
CREATE OR REPLACE TYPE  VOTAPAIS_TAB is table of VOTAPAIS_OBJ;             
/
DROP TYPE VOTATOP_TAB;
--TIPO REGISTRO DEL LISTADO DE VOTACIONES CON MAS O MENOS DIFERENCIAS PORCENTUAL
CREATE OR REPLACE TYPE VOTATOP_OBJ as object (
  TTITULO        VARCHAR2(20),
  FFECINI        DATE,
  FFECFIN        DATE,
  NCAPVOT        NUMBER(8),
  NVOTTOT        NUMBER(8),
  PPARTI         NUMBER(5,2),
  masvotada      VARCHAR2(50),
  prestotmax     NUMBER(5,2),
  menosvotada    VARCHAR2(50),
  prestotmin     NUMBER(5,2),
  diferen        NUMBER(5,2)
);
/
--TIPO QUE ALMACENA LOS REGISTROS DEL LISTADO VOTACIONES CON MAS O MENOS DIFERENCIAS PORCENTUAL
CREATE OR REPLACE TYPE  VOTATOP_TAB is table of VOTATOP_OBJ;    
/
DROP TYPE PERSOCENSO_TAB;
--TIPO REGISTRO DEL LISTADO DE CENSOS POR PERSONA
CREATE OR REPLACE TYPE PERSOCENSO_OBJ as object (
  IDPERSON       NUMBER(8),
  FNACIMI        DATE,
  CSEXPER        NUMBER(1),
  FALTA          DATE,
  FBAJA          DATE,  
  CODPAIS        VARCHAR2(2),
  TPAIS          VARCHAR2(30),
  TREGION        VARCHAR2(50),
  TLOCALI        VARCHAR2(50)
);
/
   
--TIPO QUE ALMACENA LOS REGISTROS DEL LISTADO DE CENSOS POR PERSONA 
CREATE OR REPLACE TYPE PERSOCENSO_TAB is table of PERSOCENSO_OBJ;             
/
DROP TYPE PERSOVOTA_TAB;
--TIPO REGISTRO DEL LISTADO DE VOTACIONES POR PERSONA
CREATE OR REPLACE TYPE PERSOVOTA_OBJ as object (
  IDPERSON       NUMBER(8),
  FNACIMI        DATE,
  CSEXPER        NUMBER(1),
  FALTA          DATE,
  FBAJA          DATE,  
  TTITULO        VARCHAR2(20),
  FFECINI        DATE,
  FFECFIN        DATE,
  PARTICIPO      VARCHAR2(10)
);
/
--TIPO QUE ALMACENA LOS REGISTROS DEL LISTADO DE VOTACIONES POR PERSONA 
CREATE OR REPLACE TYPE  PERSOVOTA_TAB is table of PERSOVOTA_OBJ;             
/
spool off;